﻿using CaspitWebTiles.Api.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Linq;

namespace ApiTester
{
    partial class frmMain
    {
        private void tabCC_btnCreateToken_Click(object sender, EventArgs e)
        {
            try
            {
                string url;
                CaspitCreditCard cc;

                PrepareCreditCardMessage(out url, out cc, txtDocumentKey.Text);

                string content = SendPostRequest<CaspitCreditCard>(url, cc);

                PopulateCReditCard(content);

                MessageBox.Show("Operation completed OK. Data returned:\r\n" + content, "", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void PrepareCreditCardMessage(out string url, out CaspitCreditCard cc, string p)
        {
            url = string.Format("{0}/api/v1/CreditCard?token={1}", txtUrl.Text, txtToken.Text);

            if (string.IsNullOrEmpty(tabCC_CCNumber.Text))
            {
                throw new Exception("חובה להזין את מספר הכרטיס");
            }
            if (string.IsNullOrEmpty(tabCC_ExpDate.Text))
            {
                throw new Exception("חובה להזין את תאריך התוקף");
            }

            cc = new CaspitCreditCard
            {
                CCExpDate = tabCC_ExpDate.Text,
                CCHolderTZ = tabCC_TZ.Text,
                CCNumber = tabCC_CCNumber.Text,
                CVV = tabCC_CVV.Text
            };     
        }

        private void PopulateCReditCard(string data)
        {

            try
            {
                var doc = XDocument.Parse(data);
                XNamespace ns = "http://www.caspit.biz/2013/03"; //<== the NS is taken from the CaspitDocument declaration
                XElement root = doc.Root;

                if (doc.Root.Name.LocalName != "CaspitCreditCard")
                {
                    MessageBox.Show("Could not find expected root elements in the reponse: CaspitCreditCard", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                tabCC_lblToken.Text = root.Element(ns + "CCNumberToken").Value;
                tabCC_Token.Text = root.Element(ns + "CCNumberToken").Value;

                tabCC_CVV2.Text = tabCC_CVV.Text;
                tabCC_ExpDate2.Text = tabCC_ExpDate.Text;
                tabCC_TZ2.Text = tabCC_TZ.Text;
            }
            catch
            {
                throw;
            }
        }
        
        private void tabCC_btnCharge_Click(object sender, EventArgs e)
        {
            try
            {
                string url;
                CaspitCreditCharge cc;

                PrepareCreditCardChargeMessage(out url, out cc, txtDocumentKey.Text);

                string content = SendPostRequest<CaspitCreditCharge>(url, cc);

                MessageBox.Show("Operation completed OK. Data returned:\r\n" + content, "", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void PrepareCreditCardChargeMessage(out string url, out CaspitCreditCharge cc, string p)
        {
            url = string.Format("{0}/api/v1/ChargeCreditCard?token={1}", txtUrl.Text, txtToken.Text);

            if (string.IsNullOrEmpty(tabCC_Token.Text))
            {
                throw new Exception("חובה להזין את האסימון");
            }
            if (string.IsNullOrEmpty(tabCC_ExpDate.Text))
            {
                throw new Exception("חובה להזין את תאריך התוקף");
            }

            cc = new CaspitCreditCharge
            {
                CCExpDate = tabCC_ExpDate2.Text,
                CCHolderTZ = tabCC_TZ2.Text,
                CCNumberToken = tabCC_Token.Text,
                CVV = tabCC_CVV2.Text,
                Amount = decimal.Parse(tabCC_Amount.Text),
                CreditType = int.Parse(tabCC_NumPayments.Text) > 1 ? 8 : 1,
                NumPayments = int.Parse(tabCC_NumPayments.Text),
                CurrencySymbol = "₪"
            };
        }

    }
}
