﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    /// <summary>
    /// Credit Card processing fields
    /// </summary>
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitCreditCardProcessingResult : CaspitBase
    {
        [DataMember, DefaultValue(null)]
        public bool? TrxResult { get; set; }
        [DataMember, DefaultValue(null)]
        public string CCNumber { get; set; }

        [DataMember, DefaultValue(null)]
        public string Token { get; set; }
        
        /// <summary>
        /// Expiration date (e.g. 0219 for 2q2019 or 1221 for 12/20121)
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string ExpDate { get; set; }

        /// <summary>
        /// The total amount that was charged
        /// </summary>
        public decimal? AmountCharged { get; set; }

        /// <summary>
        /// השובר עם שני החלקים: לסוחר וללקוח
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string ChargeSlip { get; set; }

        /// <summary>
        /// מספר עסקה ב-Gateway
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string ReferenceNumber { get; set; }

        /// <summary>
        /// מספר שובר
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string ChargeSlipNumber { get; set; }

        /// <summary>
        /// מספר אישור
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string AuthNumber { get; set; }

        /// <summary>
        /// Number of payments
        /// </summary>
        [DataMember]
        public int NumPayments { get; set; }

        /// <summary>
        /// The following payments. E.g. 100.00 in 3 payments ==> first pmt of 33.34 + 2 x other pmts of 33.33
        /// </summary>
        [DataMember]
        public decimal FirstPayment { get; set; }
        /// <summary>
        /// The following payments. E.g. 100.00 in 3 payments ==> first pmt of 33.34 + 2 x other pmts of 33.33
        /// </summary>
        [DataMember]
        public decimal OtherPayments { get; set; }

        /// <summary>
        /// Raw response from Shva. Not always available.
        /// </summary>
        [DataMember, DefaultValue(null)]
        public string ShvaResponse;

        /// <summary>
        /// The approval number received from Shva when preauthrizing a later charge
        /// </summary>
        [DataMember]
        public string ApprovalNumber { get; set; }

        /// <summary>
        /// Is this charge a refund
        /// </summary>
        [DataMember]
        public bool IsRefund { get; set; }
    }

}
