﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitCurrency : CaspitBase
    {
         /// <summary>
        /// סמל המטבע: $, A$ וכו'
        /// </summary>
        [DataMember, StringLength(5), Key, Required]
        public virtual string Symbol { get; set; }       
        
        /// <summary>
        /// שם המטבע: ש"ח, USD, Euro וכו'
        /// </summary>
        [DataMember, StringLength(20), Required]
        public virtual string Name { get; set; }

        /// <summary>
        /// השער בש"ח. כלומר 4.1678 פירושו 4.1678 ש"ח
        /// </summary>
        [DataMember, Required]
        public virtual decimal Rate { get; set; }
        
        /// <summary>
        /// הקוד של המטבע לפי האתר של בנק ישראל
        /// </summary>
        [DataMember, StringLength(5)]
        public virtual string Code { get; set; }
    }
}
