﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitExpensePayment
    {
        /// <summary>
        /// תאריך התשלום
        /// </summary>
        [DataMember]
        public DateTime? PaymentDate { get; set; }

        /// <summary>
        /// פרטי התשלום: אמצעי התשלום וכו'
        /// </summary>
        [DataMember]
        public string PaymentDetails { get; set; }

        /// <summary>
        /// הסכום ששולם. בדר"כ יהיה זהה לסכום ההוצאה, אבל יתכן שלא ...
        /// </summary>
        [DataMember]
        public decimal? TotalPaid { get; set; }

        /// <summary>
        /// שיק, מזומן וכו'
        /// </summary>
        [DataMember]
        public virtual int? PaymentTypeId { get; set; }

        /// <summary>
        /// מספר השיק או מספר כרטיס האשראי שבו בוצע התשלום
        /// </summary>
        [DataMember, StringLength(50)]
        public virtual string PaymentMethodNumber { get; set; }

        /// <summary>
        /// חשבון הבנק שבו שולמה ההוצאה
        /// </summary>
        [DataMember, StringLength(50)]
        public string BankAccountId { get; set; }
    }
}
