﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitLog : CaspitBase
    {
        [DataMember]
        public virtual int LogId { get; set; }

        [DataMember, Required]
        [DatabaseGenerated(DatabaseGeneratedOption.Computed)]
        public virtual DateTime DateCreated { get; set; }

        [DataMember, Required]
        public virtual DateTime DateUpdated { get; set; }

        /// <summary>
        /// 2 - Activity, 4 - Information, 3 - Error, 5 - Login, 6 - Logout, 7 - Document Creation
        /// See Globals.LogTypes
        /// </summary>
        [DataMember, Required]
        public virtual int LogType { get; set; }

        /// <summary>
        /// 0 - System, 1 - Admin
        /// See Globals.Source
        /// </summary>
        [DataMember, Required]
        public virtual int Source { get; set; }

        /// <summary>
        /// 1 - Account, 2 - Business
        /// </summary>
        [DataMember]
        public virtual int? ObjectType { get; set; }
        /// <summary>
        /// For Account - AccountId, Business - BusinessId, etc
        /// </summary>
        [DataMember]
        public virtual int? ObjectId { get; set; }

        /// <summary>
        /// תיאור חופשי
        /// </summary>
        [DataMember]
        public virtual string Content { get; set; }

        [DataMember, StringLength(20)]
        public virtual string UserName { get; set; }

        /// <summary>
        /// 192.168.589.234
        /// </summary>
        [DataMember, StringLength(14)]
        public virtual string IP { get; set; }
    }
}
