﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    /// <summary>
    /// The object used to return information from Caspit
    /// </summary>
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitResponse
    {
        /// <summary>
        /// The number of the current page. Each page contains 50 records.
        /// </summary>
        [DataMember]
        public int CurrentPage;
        /// <summary>
        /// Total number of available records.
        /// </summary>
        [DataMember]
        public int TotalCount;
        /// <summary>
        /// Total number of pages available
        /// </summary>
        [DataMember]
        public double TotalPages;

        /// <summary>
        /// A url to the previous page
        /// </summary>
        [DataMember]
        public string PrevPageUrl;

        /// <summary>
        /// A url to the following page
        /// </summary>
        [DataMember]
        public string NextPageUrl;

        /// <summary>
        /// The results from the api call
        /// A list of CaspitBase objects. CaspitBase can by a currency, a document, etc.
        /// </summary>
        [DataMember]
        public IEnumerable<CaspitBase> Results;
    }
}
