﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    /// <summary>
    /// A class to return the VAT report
    /// </summary>
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class CaspitVat : CaspitBase
    {
        [DataMember]
        public virtual int Year { get; set; }
        [DataMember]
        public virtual int Month { get; set; }
        /// <summary>
        /// סה"כ הכנסות חייבות במעמ
        /// </summary>
        [DataMember]
        public int TotalRevenuesChargeVat { get; set; }
        /// <summary>
        /// סה"כ הכנסות פטורות ממע"מ
        /// </summary>
        [DataMember]
        public int TotalRevenuesNoChargeVat { get; set; }
        /// <summary>
        /// מעמ עסקאות שנגבה מלקוחות
        /// </summary>
        [DataMember]
        public int TotalVatCharged { get; set; }
        /// <summary>
        ///מעמ תשומות (המעמ ששולם בהוצאות של העסק)
        /// </summary>
        [DataMember]
        public int TotalVatPaidInEquipment { get; set; }
        /// <summary>
        /// מעמ ששולם על ציוד קבוע
        /// </summary>
        [DataMember]
        public int TotalVatPaidInExpenses { get; set; }
        /// <summary>
        /// 16.0 for 16%
        /// </summary>
        [DataMember]
        public decimal VatRate { get; set; }
        /// <summary>
        /// סה"כ לתשלום (מספר שלילי = החזר) בש"ח
        /// </summary>
        [DataMember]
        public int VatToBePaid { get; set; }
        [DataMember]
        /// <summary>
        /// היום הראשון בתקופת המעמ
        /// </summary>
        public DateTime StartDate { get; set; }
        [DataMember]
        /// <summary>
        /// היום האחרון בתקופת המעמ
        /// </summary>
        public DateTime EndDate { get; set; }
        /// <summary>
        /// תקופת המעמ: "1-2/14"
        /// </summary>
        [DataMember]
        public string Period { get; set; }

    }
}
