﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CaspitWebTiles.Api.Models
{
    /// <summary>
    /// A list of ApiGlobals.TrxTypes and the last document number of each
    /// </summary>
    [DataContract(Namespace = "http://www.caspit.biz/2013/03")]
    public class LastDocumentsNumbersData : CaspitBase
    {
        /// <summary>
        /// The document's trx type id. The list if TrxTypes is available in ApiGlobals.TrxTypes
        /// </summary>
        [DataMember(IsRequired = true)]
        public virtual int TrxTypeId { get; set; }   //

        /// <summary>
        /// The document's id. E.g. "ecaf2261-4b47-4727-a0f1-5828fbb331e0" or  "תע_משלוח_1223" 
        /// </summary>
        [DataMember, StringLength(50)]
        public virtual string DocumentId { get; set; }

        /// <summary>
        /// The document's number. E.g. "01/10009"
        /// </summary>
        [DataMember, StringLength(50)]
        public string Number { get; set; }

        /// <summary>
        /// The document's date
        /// </summary>
        [DataMember]
        public DateTime Date { get; set; }
    }
}
